/**
 * Function to get language options.
 */
function getLanguageOptions() {
    return [
        { value: 'ar', text: 'العربية' },
        { value: 'bn', text: 'বাংলা' },
        { value: 'cn', text: '中文 (Simplified)' },
        { value: 'zh', text: '中文 (Traditional)' },
        { value: 'hr', text: 'Hrvatski' },
        { value: 'da', text: 'Dansk' },
        { value: 'nl', text: 'Nederlands' },
        { value: 'en', text: 'English' },
        { value: 'fi', text: 'Suomi' },
        { value: 'fr', text: 'Français' },
        { value: 'de', text: 'Deutsch' },
        { value: 'hi', text: 'हिन्दी' },
        { value: 'hu', text: 'Magyar' },
        { value: 'id', text: 'Bahasa Indonesia' },
        { value: 'it', text: 'Italiano' },
        { value: 'se', text: 'Sámegiella' },
        { value: 'no', text: 'Norsk' },
        { value: 'fa', text: 'فارسی' },
        { value: 'pl', text: 'Polski' },
        { value: 'pt', text: 'Português' },
        { value: 'ro', text: 'Română' },
        { value: 'ru', text: 'Русский' },
        { value: 'si', text: 'සිංහල' },
        { value: 'sk', text: 'Slovenčina' },
        { value: 'sl', text: 'Slovenščina' },
        { value: 'es', text: 'Español' },
        { value: 'th', text: 'ไทย / Phasa Thai' },
        { value: 'tr', text: 'Türkçe' },
        { value: 'vi', text: 'Tiếng Việt' }
    ];
}

/**
 * Function to get country options.
 */
function getCountryOptions() {
    return [
        { value: '2004', text: 'Afghanistan' },
        { value: '2008', text: 'Albania' },
        { value: '2012', text: 'Algeria' },
        { value: '2016', text: 'American Samoa' },
        { value: '2020', text: 'Andorra' },
        { value: '2024', text: 'Angola' },
        { value: '2010', text: 'Antarctica' },
        { value: '2028', text: 'Antigua and Barbuda' },
        { value: '2032', text: 'Argentina' },
        { value: '2051', text: 'Armenia' },
        { value: '2036', text: 'Australia' },
        { value: '2040', text: 'Austria' },
        { value: '2031', text: 'Azerbaijan' },
        { value: '2048', text: 'Bahrain' },
        { value: '2050', text: 'Bangladesh' },
        { value: '2052', text: 'Barbados' },
        { value: '2056', text: 'Belgium' },
        { value: '2084', text: 'Belize' },
        { value: '2204', text: 'Benin' },
        { value: '2064', text: 'Bhutan' },
        { value: '2068', text: 'Bolivia' },
        { value: '2070', text: 'Bosnia and Herzegovina' },
        { value: '2072', text: 'Botswana' },
        { value: '2076', text: 'Brazil' },
        { value: '2096', text: 'Brunei' },
        { value: '2100', text: 'Bulgaria' },
        { value: '2854', text: 'Burkina Faso' },
        { value: '2108', text: 'Burundi' },
        { value: '2116', text: 'Cambodia' },
        { value: '2120', text: 'Cameroon' },
        { value: '2124', text: 'Canada' },
        { value: '2132', text: 'Cape Verde' },
        { value: '2535', text: 'Caribbean Netherlands' },
        { value: '2140', text: 'Central African Republic' },
        { value: '2148', text: 'Chad' },
        { value: '2152', text: 'Chile' },
        { value: '2156', text: 'China' },
        { value: '2162', text: 'Christmas Island' },
        { value: '2166', text: 'Cocos (Keeling) Islands' },
        { value: '2170', text: 'Colombia' },
        { value: '2174', text: 'Comoros' },
        { value: '2184', text: 'Cook Islands' },
        { value: '2188', text: 'Costa Rica' },
        { value: '2384', text: "Cote d'Ivoire" },
        { value: '2191', text: 'Croatia' },
        { value: '2531', text: 'Curacao' },
        { value: '2196', text: 'Cyprus' },
        { value: '2203', text: 'Czechia' },
        { value: '2180', text: 'Democratic Republic of the Congo' },
        { value: '2208', text: 'Denmark' },
        { value: '2262', text: 'Djibouti' },
        { value: '2212', text: 'Dominica' },
        { value: '2214', text: 'Dominican Republic' },
        { value: '2218', text: 'Ecuador' },
        { value: '2818', text: 'Egypt' },
        { value: '2222', text: 'El Salvador' },
        { value: '2226', text: 'Equatorial Guinea' },
        { value: '2232', text: 'Eritrea' },
        { value: '2233', text: 'Estonia' },
        { value: '2748', text: 'Eswatini' },
        { value: '2231', text: 'Ethiopia' },
        { value: '2583', text: 'Federated States of Micronesia' },
        { value: '2242', text: 'Fiji' },
        { value: '2246', text: 'Finland' },
        { value: '2250', text: 'France' },
        { value: '2258', text: 'French Polynesia' },
        { value: '2260', text: 'French Southern and Antarctic Lands' },
        { value: '2266', text: 'Gabon' },
        { value: '2268', text: 'Georgia' },
        { value: '2276', text: 'Germany' },
        { value: '2288', text: 'Ghana' },
        { value: '2300', text: 'Greece' },
        { value: '2308', text: 'Grenada' },
        { value: '2316', text: 'Guam' },
        { value: '2320', text: 'Guatemala' },
        { value: '2831', text: 'Guernsey' },
        { value: '2324', text: 'Guinea' },
        { value: '2624', text: 'Guinea-Bissau' },
        { value: '2328', text: 'Guyana' },
        { value: '2332', text: 'Haiti' },
        { value: '2334', text: 'Heard Island and McDonald Islands' },
        { value: '2340', text: 'Honduras' },
        { value: '2348', text: 'Hungary' },
        { value: '2352', text: 'Iceland' },
        { value: '2356', text: 'India' },
        { value: '2360', text: 'Indonesia' },
        { value: '2368', text: 'Iraq' },
        { value: '2372', text: 'Ireland' },
        { value: '2833', text: 'Isle of Man' },
        { value: '2376', text: 'Israel' },
        { value: '2380', text: 'Italy' },
        { value: '2388', text: 'Jamaica' },
        { value: '2392', text: 'Japan' },
        { value: '2832', text: 'Jersey' },
        { value: '2400', text: 'Jordan' },
        { value: '2398', text: 'Kazakhstan' },
        { value: '2404', text: 'Kenya' },
        { value: '2296', text: 'Kiribati' },
        { value: '2414', text: 'Kuwait' },
        { value: '2417', text: 'Kyrgyzstan' },
        { value: '2418', text: 'Laos' },
        { value: '2428', text: 'Latvia' },
        { value: '2422', text: 'Lebanon' },
        { value: '2426', text: 'Lesotho' },
        { value: '2430', text: 'Liberia' },
        { value: '2434', text: 'Libya' },
        { value: '2438', text: 'Liechtenstein' },
        { value: '2440', text: 'Lithuania' },
        { value: '2442', text: 'Luxembourg' },
        { value: '2450', text: 'Madagascar' },
        { value: '2454', text: 'Malawi' },
        { value: '2458', text: 'Malaysia' },
        { value: '2462', text: 'Maldives' },
        { value: '2466', text: 'Mali' },
        { value: '2470', text: 'Malta' },
        { value: '2584', text: 'Marshall Islands' },
        { value: '2478', text: 'Mauritania' },
        { value: '2480', text: 'Mauritius' },
        { value: '2484', text: 'Mexico' },
        { value: '2498', text: 'Moldova' },
        { value: '2492', text: 'Monaco' },
        { value: '2496', text: 'Mongolia' },
        { value: '2499', text: 'Montenegro' },
        { value: '2504', text: 'Morocco' },
        { value: '2508', text: 'Mozambique' },
        { value: '2104', text: 'Myanmar (Burma)' },
        { value: '2516', text: 'Namibia' },
        { value: '2520', text: 'Nauru' },
        { value: '2524', text: 'Nepal' },
        { value: '2528', text: 'Netherlands' },
        { value: '2540', text: 'New Caledonia' },
        { value: '2554', text: 'New Zealand' },
        { value: '2558', text: 'Nicaragua' },
        { value: '2562', text: 'Niger' },
        { value: '2566', text: 'Nigeria' },
        { value: '2570', text: 'Niue' },
        { value: '2574', text: 'Norfolk Island' },
        { value: '2807', text: 'North Macedonia' },
        { value: '2580', text: 'Northern Mariana Islands' },
        { value: '2578', text: 'Norway' },
        { value: '2512', text: 'Oman' },
        { value: '2586', text: 'Pakistan' },
        { value: '2585', text: 'Palau' },
        { value: '2591', text: 'Panama' },
        { value: '2598', text: 'Papua New Guinea' },
        { value: '2600', text: 'Paraguay' },
        { value: '2604', text: 'Peru' },
        { value: '2608', text: 'Philippines' },
        { value: '2612', text: 'Pitcairn Islands' },
        { value: '2616', text: 'Poland' },
        { value: '2620', text: 'Portugal' },
        { value: '2634', text: 'Qatar' },
        { value: '2178', text: 'Republic of the Congo' },
        { value: '2642', text: 'Romania' },
        { value: '2643', text: 'Russia' },
        { value: '2646', text: 'Rwanda' },
        { value: '2654', text: 'Saint Helena, Ascension and Tristan da Cunha' },
        { value: '2659', text: 'Saint Kitts and Nevis' },
        { value: '2662', text: 'Saint Lucia' },
        { value: '2666', text: 'Saint Pierre and Miquelon' },
        { value: '2670', text: 'Saint Vincent and the Grenadines' },
        { value: '2882', text: 'Samoa' },
        { value: '2674', text: 'San Marino' },
        { value: '2678', text: 'Sao Tome and Principe' },
        { value: '2682', text: 'Saudi Arabia' },
        { value: '2686', text: 'Senegal' },
        { value: '2688', text: 'Serbia' },
        { value: '2690', text: 'Seychelles' },
        { value: '2694', text: 'Sierra Leone' },
        { value: '2702', text: 'Singapore' },
        { value: '2534', text: 'Sint Maarten' },
        { value: '2703', text: 'Slovakia' },
        { value: '2705', text: 'Slovenia' },
        { value: '2090', text: 'Solomon Islands' },
        { value: '2706', text: 'Somalia' },
        { value: '2710', text: 'South Africa' },
        { value: '2239', text: 'South Georgia and the South Sandwich Islands' },
        { value: '2410', text: 'South Korea' },
        { value: '2724', text: 'Spain' },
        { value: '2144', text: 'Sri Lanka' },
        { value: '2740', text: 'Suriname' },
        { value: '2752', text: 'Sweden' },
        { value: '2756', text: 'Switzerland' },
        { value: '2762', text: 'Tajikistan' },
        { value: '2834', text: 'Tanzania' },
        { value: '2158', text: 'Taiwan' },
        { value: '2764', text: 'Thailand' },
        { value: '2044', text: 'The Bahamas' },
        { value: '2270', text: 'The Gambia' },
        { value: '2626', text: 'Timor-Leste' },
        { value: '2768', text: 'Togo' },
        { value: '2772', text: 'Tokelau' },
        { value: '2776', text: 'Tonga' },
        { value: '2780', text: 'Trinidad and Tobago' },
        { value: '2788', text: 'Tunisia' },
        { value: '2792', text: 'Turkey' },
        { value: '2795', text: 'Turkmenistan' },
        { value: '2798', text: 'Tuvalu' },
        { value: '2800', text: 'Uganda' },
        { value: '2804', text: 'Ukraine' },
        { value: '2784', text: 'United Arab Emirates' },
        { value: '2826', text: 'United Kingdom' },
        { value: '2840', text: 'United States' },
        { value: '2581', text: 'United States Minor Outlying Islands' },
        { value: '2858', text: 'Uruguay' },
        { value: '2860', text: 'Uzbekistan' },
        { value: '2548', text: 'Vanuatu' },
        { value: '2336', text: 'Vatican City' },
        { value: '2862', text: 'Venezuela' },
        { value: '2704', text: 'Vietnam' },
        { value: '2876', text: 'Wallis and Futuna' },
        { value: '2887', text: 'Yemen' },
        { value: '2894', text: 'Zambia' },
        { value: '2716', text: 'Zimbabwe' }
    ];
}

function getAllinwriterContent() {
    let postTitle = '';
    let postContent = '';

    // Gutenberg
    if (window.wp && window.wp.data 
        && typeof wp.data.select('core/editor') !== 'undefined' 
        && typeof wp.data.select('core/editor').getEditedPostAttribute === 'function') {
        postTitle = wp.data.select('core/editor').getEditedPostAttribute('title');
        postContent = wp.data.select('core/editor').getEditedPostContent();
    }
    // Classic Editor
    else if (document.getElementById('content') && document.getElementById('title')) {
        postTitle = document.getElementById('title').value;
        postContent = document.getElementById('content').value;
    }
    // Elementor
    else if (typeof elementor !== 'undefined') {
        let titleInput = document.querySelector('input[data-setting="post_title"]');
        if (titleInput) {
            postTitle = titleInput.value;
        }

        const contentElements = document.querySelectorAll('.elementor-widget-container');
        postContent = Array.from(contentElements).map(el => el.innerHTML).join('');

        if (!postContent && allinwriter_vars && allinwriter_vars.allinwriter_post_id) {
            const autosaveKey = `wp-autosave-block-editor-post-${allinwriter_vars.allinwriter_post_id}`;
            const autosaveData = sessionStorage.getItem(autosaveKey);

            if (autosaveData) {
                try {
                    const parsedData = JSON.parse(autosaveData);
                    if (parsedData) {
                        postTitle = parsedData.post_title || postTitle;
                        postContent = parsedData.content || postContent;
                    }
                } catch (e) {
                    console.error('Failed to parse session storage data:', e);
                }
            }
        }
    }
    // Visual Composer
    else if (typeof vc !== 'undefined') {
        let titleInput = document.querySelector('.post-title-input');
        if (titleInput) {
            postTitle = titleInput.value;
            const contentElement = document.querySelector('.vc_element');
            if (contentElement) {
                postContent = contentElement.innerHTML;
            }
        }
    }

    return `<h1>${postTitle}</h1>${postContent}`;
}

let maxAttempts = 8;
let maxTimePerAttempt = 7000; // 7 seconds
let allinWriterWPEditor = false;
let allinWriterWPselection = false;
let allinWriterWPVoices = [];
let allinWriterWPFirstLoad = true;
let allinWriterWPDescription = '';

const allinWriterWPSocketConnections = new Map();
const allinWriterWPJobActions = new Map();
const ALLINWRITER_MAX_CONNECTIONS = 5;

let allinWriterWPWarningOptions = {
    closeButton: true,
    debug: false,
    newestOnTop: true,
    progressBar: false,
    positionClass: "toast-centered",
    preventDuplicates: false,
    onclick: null,
    showDuration: "300",
    hideDuration: "1000",
    timeOut: "0",
    extendedTimeOut: "0",
    showEasing: "swing",
    hideEasing: "linear",
    showMethod: "fadeIn",
    hideMethod: "fadeOut"
};

const allinWriterWPUrlImages = `https://app.allinwriter.com/uploads/users/images/`;
let allinWriterWPPreloaderOverlay;
let allinWriterWPMessageInterval;
let allinWriterWPProgressBar;
let allinWriterWPPreloadTimeout;
let allinWriterWPMessageElement;
let allinWriterWPProgressInterval;

/**
 * Function to close the overlay.
 * @param {HTMLElement} overlay - The overlay to close.
 */
function closeOverlay(overlay) {
    if (document.body.contains(overlay)) {
        document.body.removeChild(overlay);
    }
    allinWriterWPEditor = false;
    allinWriterWPVoices = [];
}

/**
 * Setup function to close overlay on Escape key press.
 * @param {HTMLElement} overlay - The overlay to close.
 */
function setupCloseOnEscape(overlay) {
    function handleCloseOnEscape(event) {
        if (event.key === "Escape") {
            closeOverlay(overlay);
            document.removeEventListener('keydown', handleCloseOnEscape);
        }
    }
    document.addEventListener('keydown', handleCloseOnEscape);
}

/**
 * Fallback function to copy text to clipboard.
 * @param {string} text - The text to copy.
 */
function copyTextFallback(text) {
    const textArea = document.createElement('textarea');
    textArea.value = text;

    textArea.style.position = 'fixed';
    textArea.style.left = '-9999px';

    document.body.appendChild(textArea);

    textArea.select();

    try {
        const successful = document.execCommand('copy');
        if (successful) {
            toastr.success('The text was copied to clipboard! You can paste it.');
        } else {
            toastr.warning('Failed to copy the text to clipboard.', 'Heads Up', allinWriterWPWarningOptions);
        }
    } catch (err) {
        toastr.error('Unable to copy to clipboard.');
    }

    document.body.removeChild(textArea);
}

/**
 * Create a preloader overlay with messages.
 * @param {Array<string>} messages - Messages to display.
 * @param {number} totalDuration - Total duration for the preloader.
 * @param {string} estimatedTimeText - Optional text for estimated time.
 */
function createPreloader(messages, totalDuration, estimatedTimeText = '') {
    let currentMessageIndex = 0;

    allinWriterWPPreloaderOverlay = document.createElement('div');
    allinWriterWPPreloaderOverlay.style.position = 'fixed';
    allinWriterWPPreloaderOverlay.style.top = 0;
    allinWriterWPPreloaderOverlay.style.left = 0;
    allinWriterWPPreloaderOverlay.style.width = '100%';
    allinWriterWPPreloaderOverlay.style.height = '100%';
    allinWriterWPPreloaderOverlay.style.backgroundColor = 'rgba(0, 0, 0, 0.7)';
    allinWriterWPPreloaderOverlay.style.display = 'flex';
    allinWriterWPPreloaderOverlay.style.alignItems = 'center';
    allinWriterWPPreloaderOverlay.style.justifyContent = 'center';
    allinWriterWPPreloaderOverlay.style.zIndex = 9999;
    allinWriterWPPreloaderOverlay.style.flexDirection = 'column';
    allinWriterWPPreloaderOverlay.classList.add('allinwriter-wp-preloader-overlay');

    const preloader = document.createElement('div');
    preloader.style.width = '50px';
    preloader.style.height = '50px';
    preloader.style.border = '5px solid #f3f3f3';
    preloader.style.borderTop = '5px solid #8b5cf6';
    preloader.style.borderRadius = '50%';
    preloader.style.animation = 'spin 1s linear infinite';

    const logoPreloader = document.createElement('img');
    logoPreloader.src = 'icon path for preloader'; // Replace with correct path
    logoPreloader.classList.add('allinwriter-logo-preloader');

    allinWriterWPPreloaderOverlay.appendChild(logoPreloader);

    const style = document.createElement('style');
    style.type = 'text/css';
    style.innerHTML = `@keyframes spin { from { transform: rotate(0deg); } to { transform: rotate(360deg); } }`;
    document.head.appendChild(style);

    const allinWriterWPMessageElement = document.createElement('p');
    allinWriterWPMessageElement.style.color = 'white';
    allinWriterWPMessageElement.style.marginTop = '20px';
    allinWriterWPMessageElement.innerText = messages[0];

    allinWriterWPPreloaderOverlay.appendChild(preloader);
    allinWriterWPPreloaderOverlay.appendChild(allinWriterWPMessageElement);

    const estimatedTimeElement = document.createElement('p');
    estimatedTimeElement.style.color = 'white';
    estimatedTimeElement.style.marginTop = '10px';
    estimatedTimeElement.style.fontStyle = 'italic';
    estimatedTimeElement.style.position = 'absolute';
    estimatedTimeElement.style.transform = 'translateY(70px)';
    estimatedTimeElement.innerHTML = estimatedTimeText;

    if (estimatedTimeText) {
        allinWriterWPPreloaderOverlay.appendChild(estimatedTimeElement);
    }

    const closeButton = document.createElement('div');
    closeButton.innerText = 'X';
    closeButton.classList.add("allinwriter-close-btn-loader");
    closeButton.id = "allinwriter-close-btn-loader-preloader";
    closeButton.title = "You don't have to wait. Close it and you will find the result later in the documents";
    closeButton.style.border = '0';
    closeButton.style.cursor = 'pointer';
    closeButton.innerHTML = `<svg role="img" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><title/><path d="M13.7 19.55l5.88-5.89 3.35 3.36a3.57 3.57 0 0 1 0 5.05l-.83.83a3.57 3.57 0 0 1-5.05 0zM22.92 1.9l-.83-.83a3.57 3.57 0 0 0-5.05 0L12 6.12 6.95 1.07a3.57 3.57 0 0 0-5.05 0l-.83.83a3.57 3.57 0 0 0 0 5.05L6.12 12l-5.05 5.05a3.57 3.57 0 0 0 0 5.05l.83.83a3.57 3.57 0 0 0 5.05 0L12 17.88l3.68-3.68 2.2-2.2 5.05-5.05a3.57 3.57 0 0 0 0-5.05z"/></svg>`;
    closeButton.onclick = () => { document.body.removeChild(allinWriterWPPreloaderOverlay); allinWriterWPEditor = false; };
    allinWriterWPPreloaderOverlay.appendChild(closeButton);

    document.body.appendChild(allinWriterWPPreloaderOverlay);
    setupCloseOnEscape(allinWriterWPPreloaderOverlay);

    jQuery("#allinwriter-close-btn-loader-preloader").tooltipster({
        theme: 'tooltipster-borderless',
        delay: [0, 0],
        side: 'bottom'
    });

    const messageDurations = [
        totalDuration * 0.10,
        totalDuration * 0.30,
        totalDuration * 0.60 / (messages.length - 2),
    ];

    function showNextMessage() {
        currentMessageIndex++;
        if (currentMessageIndex < messages.length) {
            allinWriterWPMessageElement.innerText = messages[currentMessageIndex];
            setTimeout(showNextMessage, messageDurations[currentMessageIndex]);
        } else {
            stopPreloader();
        }
    }

    setTimeout(showNextMessage, messageDurations[0]);
    allinWriterWPPreloadTimeout = setTimeout(stopPreloader, totalDuration);
}

/**
 * Create a progress bar preloader overlay.
 * @param {Array<string>} messages - Messages to display.
 * @param {number} totalDuration - Duration for the progress bar preloader.
 * @param {string} estimatedTimeText - Optional text for estimated time.
 */
function createProgressBarPreloader(messages, totalDuration, estimatedTimeText = '') {
    let currentMessageIndex = 0;

    allinWriterWPPreloaderOverlay = document.createElement('div');
    allinWriterWPPreloaderOverlay.style.position = 'fixed';
    allinWriterWPPreloaderOverlay.style.top = 0;
    allinWriterWPPreloaderOverlay.style.left = 0;
    allinWriterWPPreloaderOverlay.style.width = '100%';
    allinWriterWPPreloaderOverlay.style.height = '100%';
    allinWriterWPPreloaderOverlay.style.backgroundColor = 'rgba(0, 0, 0, 0.5)';
    allinWriterWPPreloaderOverlay.style.display = 'flex';
    allinWriterWPPreloaderOverlay.style.alignItems = 'center';
    allinWriterWPPreloaderOverlay.style.justifyContent = 'center';
    allinWriterWPPreloaderOverlay.style.zIndex = 9999;
    allinWriterWPPreloaderOverlay.style.flexDirection = 'column';
    allinWriterWPPreloaderOverlay.classList.add('allinwriter-wp-preloader-overlay');

    const allinWriterWPProgressBarContainer = document.createElement('div');
    allinWriterWPProgressBarContainer.style.width = '200px';
    allinWriterWPProgressBarContainer.style.backgroundColor = '#fff';
    allinWriterWPProgressBarContainer.style.borderRadius = '7px';
    allinWriterWPProgressBarContainer.style.overflow = 'hidden';

    allinWriterWPProgressBar = document.createElement('div');
    allinWriterWPProgressBar.style.width = '0%';
    allinWriterWPProgressBar.style.height = '7px';
    allinWriterWPProgressBar.style.backgroundColor = '#8b5cf6';

    allinWriterWPProgressBarContainer.appendChild(allinWriterWPProgressBar);

    allinWriterWPMessageElement = document.createElement('p');
    allinWriterWPMessageElement.style.color = 'white';
    allinWriterWPMessageElement.style.marginTop = '20px';
    allinWriterWPMessageElement.innerText = messages[0];

    allinWriterWPPreloaderOverlay.appendChild(allinWriterWPProgressBarContainer);
    allinWriterWPPreloaderOverlay.appendChild(allinWriterWPMessageElement);

    const estimatedTimeElement = document.createElement('p');
    estimatedTimeElement.style.color = 'white';
    estimatedTimeElement.style.marginTop = '10px';
    estimatedTimeElement.style.fontStyle = 'italic';
    estimatedTimeElement.style.position = 'absolute';
    estimatedTimeElement.style.transform = 'translateY(70px)';
    estimatedTimeElement.style.textAlign = 'center';
    estimatedTimeElement.innerHTML = estimatedTimeText;

    if (estimatedTimeText) {
        allinWriterWPPreloaderOverlay.appendChild(estimatedTimeElement);
    }

    const closeButton = document.createElement('div');
    closeButton.innerText = 'X';
    closeButton.classList.add("allinwriter-close-btn-loader");
    closeButton.id = "allinwriter-close-btn-loader-preloader";
    closeButton.title = "You don't have to wait. Close it and you will find the result later in the documents";
    closeButton.style.border = '0';
    closeButton.style.cursor = 'pointer';
    closeButton.innerHTML = `<svg role="img" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><title/><path d="M13.7 19.55l5.88-5.89 3.35 3.36a3.57 3.57 0 0 1 0 5.05l-.83.83a3.57 3.57 0 0 1-5.05 0zM22.92 1.9l-.83-.83a3.57 3.57 0 0 0-5.05 0L12 6.12 6.95 1.07a3.57 3.57 0 0 0-5.05 0l-.83.83a3.57 3.57 0 0 0 0 5.05L6.12 12l-5.05 5.05a3.57 3.57 0 0 0 0 5.05l.83.83a3.57 3.57 0 0 0 5.05 0L12 17.88l3.68-3.68 2.2-2.2 5.05-5.05a3.57 3.57 0 0 0 0-5.05z"/></svg>`;
    closeButton.onclick = () => { document.body.removeChild(allinWriterWPPreloaderOverlay); allinWriterWPEditor = false; };
    allinWriterWPPreloaderOverlay.appendChild(closeButton);

    document.body.appendChild(allinWriterWPPreloaderOverlay);
    setupCloseOnEscape(allinWriterWPPreloaderOverlay);

    jQuery("#allinwriter-close-btn-loader-preloader").tooltipster({
        theme: 'tooltipster-borderless',
        delay: [0, 0],
        side: 'bottom'
    });

    const updateInterval = 100;
    const progressStep = 100 / (totalDuration / updateInterval);

    allinWriterWPProgressInterval = setInterval(() => {
        let currentWidth = parseFloat(allinWriterWPProgressBar.style.width);
        if (currentWidth < 100) {
            allinWriterWPProgressBar.style.width = (currentWidth + progressStep) + '%';
        } else {
            clearInterval(allinWriterWPProgressInterval);
        }
    }, updateInterval);

    const messageDurations = [
        totalDuration * 0.10,
        totalDuration * 0.30,
        totalDuration * 0.60 / (messages.length - 2),
    ];

    function showNextMessage() {
        currentMessageIndex++;
        if (currentMessageIndex < messages.length) {
            allinWriterWPMessageElement.innerText = messages[currentMessageIndex];
            setTimeout(showNextMessage, messageDurations[Math.min(currentMessageIndex, messageDurations.length - 1)]);
        } else {
            stopPreloader();
        }
    }

    setTimeout(showNextMessage, messageDurations[0]);
    allinWriterWPPreloadTimeout = setTimeout(stopPreloader, totalDuration);
}

/**
 * Stop and remove the preloader.
 */
function stopPreloader() {
    if (allinWriterWPProgressInterval) {
        clearInterval(allinWriterWPProgressInterval);
    }
    if (allinWriterWPMessageInterval) {
        clearInterval(allinWriterWPMessageInterval);
    }
    if (allinWriterWPPreloadTimeout) {
        clearTimeout(allinWriterWPPreloadTimeout);
    }
    if (allinWriterWPProgressBar) {
        allinWriterWPProgressBar.style.width = '100%';
        setTimeout(() => {
            if (document.body.contains(allinWriterWPPreloaderOverlay)) {
                document.body.removeChild(allinWriterWPPreloaderOverlay);
            }
        }, 1000);
    } else {
        if (document.body.contains(allinWriterWPPreloaderOverlay)) {
            document.body.removeChild(allinWriterWPPreloaderOverlay);
        }
    }
}

/**
 * Animate the score element to a target score over a duration.
 * @param {HTMLElement} scoreElement - Element to update with score.
 * @param {number} targetScore - The score to reach.
 * @param {number} duration - Duration for the animation.
 */
function animateScore(scoreElement, targetScore, duration) {
    let currentScore = 0;
    const interval = 10;
    const steps = duration / interval;
    const increment = targetScore / steps;

    const intervalId = setInterval(() => {
        currentScore += increment;

        if (currentScore >= targetScore) {
            currentScore = targetScore;
            clearInterval(intervalId);
        }

        scoreElement.innerText = Math.floor(currentScore);
    }, interval);
}

jQuery(document).ready(function ($) {
    const faqs = document.querySelectorAll('#allinwriter-container-wp #faq-tab ul li');
    const allinwriterMenuContainer = document.getElementById('allinwriter-main-menu-seo-article-container');
    const allinwriterMoveButton = document.getElementById('allinwriter-move-button-wp');
    
    if(allinwriterMenuContainer) {

        allinwriterMenuContainer.addEventListener('mousedown', allinwriterStartDrag);
    
        const cookieValue = allinwriterGetCookie('allinwriter_position_wp');
        if (cookieValue) {
            const position = JSON.parse(cookieValue);
            const { top, left } = position;
            allinwriterMenuContainer.style.top = top;
            allinwriterMenuContainer.style.left = left;
        }
        allinwriterMenuContainer.style.display = 'block';
    
        let allinwriterOffsetX, allinwriterOffsetY;
    
        function allinwriterStartDrag(event) {
            if (event.target !== allinwriterMoveButton) return;
        
            allinwriterOffsetX = event.clientX - allinwriterMenuContainer.offsetLeft;
            allinwriterOffsetY = event.clientY - allinwriterMenuContainer.offsetTop;
        
            document.addEventListener('mousemove', allinwriterPerformDrag);
            document.addEventListener('mouseup', allinwriterStopDrag);
        
            allinwriterMenuContainer.style.transition = 'none';
        }
        
        function allinwriterPerformDrag(event) {
            const allinwriterViewportWidth = window.innerWidth;
            const allinwriterViewportHeight = window.innerHeight;
            
            const allinwriterElementWidth = 160;
            const allinwriterElementHeight = 118;
        
            let newLeft = event.clientX - allinwriterOffsetX;
            let newTop = event.clientY - allinwriterOffsetY;
        
            if (newLeft < allinwriterElementWidth/3) {
                newLeft = allinwriterElementWidth/3;
            } else if (newLeft + allinwriterElementWidth > allinwriterViewportWidth) {
                newLeft = allinwriterViewportWidth - allinwriterElementWidth;
            }
        
            if (newTop < allinwriterElementHeight/3) {
                newTop = allinwriterElementHeight/3;
            } else if (newTop + allinwriterElementHeight > allinwriterViewportHeight) {
                newTop = allinwriterViewportHeight - allinwriterElementHeight;
            }
        
            allinwriterMenuContainer.style.left = `${newLeft}px`;
            allinwriterMenuContainer.style.top = `${newTop}px`;
        }
        
        function allinwriterStopDrag() {
            document.removeEventListener('mousemove', allinwriterPerformDrag);
            document.removeEventListener('mouseup', allinwriterStopDrag);
    
            // Save position in cookie
            document.cookie = `allinwriter_position_wp=${JSON.stringify(
               {
                   top: allinwriterMenuContainer.style.top,
                   left: allinwriterMenuContainer.style.left
               }
           )}; path=/`;
        }
    
        function allinwriterGetCookie(name) {
            const value = `; ${document.cookie}`;
            const parts = value.split(`; ${name}=`);
            if (parts.length === 2) return parts.pop().split(';').shift();
        }
    }

    jQuery('#allinwriter-disconnect-btn').attr('title', 'Disconnect');
    jQuery('#allinwriter-disconnect-btn').tooltipster({
        theme: 'tooltipster-borderless',
        delay: [0, 0],
        side: 'bottom'
    });

    jQuery('#allinwriter-sync-btn').attr('title', 'Sync');
    jQuery('#allinwriter-sync-btn').tooltipster({
        theme: 'tooltipster-borderless',
        delay: [0, 0],
        side: 'bottom'
    });

    toastr.options = {
        closeButton: true,
        debug: false,
        newestOnTop: false,
        allinWriterWPProgressBar: true,
        positionClass: "toast-bottom-right",
        preventDuplicates: false,
        showDuration: "300",
        hideDuration: "1000",
        timeOut: "5000",
        extendedTimeOut: "1000",
        showEasing: "swing",
        hideEasing: "linear",
        showMethod: "fadeIn",
        hideMethod: "fadeOut"
    };

    faqs.forEach(faq => {
        faq.addEventListener('click', () => {
            faq.classList.toggle('active');
            const childUl = faq.querySelector('ul');
            if (childUl) {
                childUl.classList.toggle('active');
            }
        });
    });

    if (allinwriter_vars.connected) {
        $('#allinwriter-disconnect-btn').show();
    }

    if (allinwriter_vars.score && parseInt(allinwriter_vars.score) >= 0) {
        jQuery(".allinwriter-speedometer-container").css('visibility', 'visible');

        const element = document.getElementById('allinwriter-indicator');
        const scoreElement = document.querySelector('#allinwriter-score');

        if (element) {
            element.style.setProperty('--allinwriter-score', allinwriter_vars.score);

            const targetScore = allinwriter_vars.score || 0;

            if (scoreElement) {
                animateScore(scoreElement, targetScore, 100);

                let tooltipSEOScore = '';
    
                if (allinwriter_vars.score >= 55 && allinwriter_vars.score < 90) {
                    tooltipSEOScore = 'You have a 42% increased chance of ranking in top Google.';
                } else if (allinwriter_vars.score >= 90) {
                    tooltipSEOScore = 'You have over a 500% increased chance of ranking in top Google even for hard keywords.';
                }
    
                scoreElement.title = tooltipSEOScore;

                    if(tooltipSEOScore) {
                        setTimeout(function () {
                            jQuery(".allinwriter-speedometer-container").tooltipster({
                                theme: 'tooltipster-borderless',
                                delay: [0, 0],
                                side: 'top'
                            });
                            jQuery('.allinwriter-check-score').attr('title', 'Check score');
                            jQuery('.allinwriter-check-score').tooltipster({
                                theme: 'tooltipster-borderless',
                                delay: [0, 0],
                                side: 'bottom'
                            });
                        }, 500);
                    }
            }
        }
    } else {
        const element = document.getElementById('allinwriter-indicator');
        const scoreElement = document.querySelector('#allinwriter-score');

        if(element) {
            element.style.setProperty('--allinwriter-score', 0);
        }

        if(scoreElement) {
            scoreElement.innerText = 'N/A';
        }
    }

    $('#allinwriter-api-key-form').on('submit', function (e) {
        e.preventDefault();

        const apiKey = $('#allinwriter-api-key').val();

        $.ajax({
            url: allinwriter_vars.ajax_url,
            type: 'POST',
            data: {
                action: 'allinwriter_validate_api_key',
                security: allinwriter_vars.nonce,
                api_key: apiKey
            },
            success: function (response) {
                if (response.success) {
                    toastr.success(response.data.message);
                    window.location.reload();
                } else {
                    toastr.warning(response.data.message);
                }
            }
        });
    });

    $('.allinwriter-check-score').on('click', function () {
        $('.allinwriter-speedometer').addClass('allinwriter-loading');
        let content = getAllinwriterContent();

        if( content ) {
            $.ajax({
                url: allinwriter_vars.ajax_url,
                type: 'POST',
                data: { action: 'allinwriter_check_score',
                        post_id: allinwriter_vars.allinwriter_post_id, 
                        content: getAllinwriterContent(),
                        security: allinwriter_vars.nonce },
                success: function (response) {
                    if (response.success) {
                        const element = document.getElementById('allinwriter-indicator');
                        const scoreElement = document.querySelector('#allinwriter-score');
    
                        element.style.setProperty('--allinwriter-score', response.data.seo_score);
    
                        animateScore(scoreElement, response.data.seo_score, 100);
                    } else {
                        toastr.warning(response.data.message);
                    }
                    $('.allinwriter-speedometer').removeClass('allinwriter-loading');
                }
            });
        } else {
            toastr.warning('There is not enough content.');
        }
    });

    $('#allinwriter-sync-btn').on('click', function () {
        $('#allinwriter-sync-btn').addClass('allinwriter-loading');

        $.ajax({
            url: allinwriter_vars.ajax_url,
            type: 'POST',
            data: { action: 'allinwriter_sync_account',
                    security: allinwriter_vars.nonce },
            success: function (response) {
                if (response.success) {
                    window.location.reload();
                } else {
                    toastr.warning(response.data.message);
                    $('#allinwriter-sync-btn').removeClass('allinwriter-loading');
                }
            }
        });
    });

    $('#allinwriter-disconnect-btn').on('click', function () {
        $.ajax({
            url: allinwriter_vars.ajax_url,
            type: 'POST',
            data: { action: 'allinwriter_disconnect_user', security: allinwriter_vars.nonce },
            success: function (response) {
                if (response.success) {
                    toastr.success(response.data.message);
                    $('#allinwriter-disconnect-btn').hide();
                    window.location.href = 'admin.php?page=allinwriter-seo-articles';
                } else {
                    toastr.error('Failed to disconnect.');
                }
            }
        });
    });

    $('#allinwriter-btn').on('click', function () {
        const isProUser = allinwriter_vars.user_plan !== 'free';
        const goProButton = isProUser ? '' : '<a href="https://app.allinwriter.com/plans" target="_blank" class="allinwriter-go-pro">GO PRO</a>';
        const allinwriter_fields = `<input id="allinwriter-type" name="type" value="generateArticle" type="hidden">
                                    <input id="allinwriter-method-type" name="type" type="hidden" value="write">`;

        $('body').append(`
            <div id="allinwriter-modal" class="allinwriter-modal">
                <div class="allinwriter-modal-content allinwriter-popup">
                    <span class="allinwriter-close">&times;</span>
                    <h2>Generate SEO Article</h2>
                    <form id="allinwriter-form">
                        <label for="allinwriter-keyword">Keyword*:</label>
                        <input type="text" id="allinwriter-keyword" name="keyword" required>

                        ${allinwriter_vars.custom_fields ? allinwriter_vars.custom_fields: allinwriter_fields}

                        <div class="allinwriter-description-container">
                            <label for="allinwriter-description">Description:</label>
                            <textarea id="allinwriter-description" name="description"></textarea>
                        </div>
                        <input id="allinwriter-rewrite-text" name="allinwriter-rewrite-text" type="hidden">
                        
                        <label for="allinwriter-language">Language*:</label>
                        <select id="allinwriter-language" name="language" required></select>

                        <label for="allinwriter-country">Country*:</label>
                        <select id="allinwriter-country" name="country" required></select>
                        ${!isProUser ? goProButton : ''}
                        
                        <button type="submit" class="allinwriter-button allinwriter-button-primary">Generate</button>
                    </form>
                </div>
            </div>
        `);

        getLanguageOptions().forEach(({ value, text }) => {
            const option = value === 'en' ? 
                `<option value="${value}" selected>${text}</option>` : 
                `<option value="${value}">${text}</option>`;
            $('#allinwriter-language').append(option);
        });

        getCountryOptions().forEach(({ value, text }) => {
            const option = value === '2840' ? 
                `<option value="${value}" selected>${text}</option>` : 
                `<option value="${value}">${text}</option>`;
            $('#allinwriter-country').append(option);
        });
        $('#allinwriter-modal').fadeIn();

        $('#allinwriter-type').unbind('change');
        $('#allinwriter-type').bind('change', function(e){
            let type = this.value;
            let currentUrl = window.location.pathname;
            let isEditPost = currentUrl.includes('post.php');

            if($('#allinwriter-description').val()) {
                allinWriterWPDescription = $('#allinwriter-description').val();
            }

            if(type === 'generateArticlePRO' && isEditPost) {
                $('.allinwriter-write-method').show();
                
                let writeMethod = $('#allinwriter-method-type').val();

                if(writeMethod == 'rewrite') {
                    $('.allinwriter-description-container').hide();
                    $('#allinwriter-description').val('');
                    $('#allinwriter-rewrite-text').val(getAllinwriterContent());
                } else {
                    $('#allinwriter-description').val(allinWriterWPDescription);
                    $('#allinwriter-rewrite-text').val('');
                }
            } else {
                $('.allinwriter-write-method').hide();
                let writeMethod = $('#allinwriter-method-type').val();

                if(writeMethod == 'rewrite') {
                    $('#allinwriter-description').val('');
                    $('.allinwriter-description-container').show();
                } else {
                    $('#allinwriter-description').val(allinWriterWPDescription);
                    $('#allinwriter-rewrite-text').val('');
                }
            }
        });

        $('#allinwriter-method-type').unbind('change');
        $('#allinwriter-method-type').bind('change', function(e){
            let type = $('#allinwriter-type').val();
            let currentUrl = window.location.pathname;
            let isEditPost = currentUrl.includes('post.php');

            if($('#allinwriter-description').val()) {
                allinWriterWPDescription = $('#allinwriter-description').val();
            }

            if(type === 'generateArticlePRO' && isEditPost) {
                $('.allinwriter-description-container').hide();
                
                let writeMethod = this.value;

                if(writeMethod == 'rewrite') {
                    $('#allinwriter-description').val('');
                    $('#allinwriter-rewrite-text').val(getAllinwriterContent());
                } else {
                    $('#allinwriter-description').val(allinWriterWPDescription);
                    $('#allinwriter-rewrite-text').val('');
                    $('.allinwriter-description-container').show();
                }
            } else {
                $('.allinwriter-description-container').show();
                let writeMethod = this.value;

                if(writeMethod == 'rewrite') {
                    $('#allinwriter-description').val('');
                } else {
                    $('#allinwriter-description').val(allinWriterWPDescription);
                    $('#allinwriter-rewrite-text').val('');
                    $('.allinwriter-description-container').show();
                }
            }
        });
    });

    $(document).on('click', '.allinwriter-close', function () {
        $('#allinwriter-modal').fadeOut(function () {
            $(this).remove();
        });
    });

    $(document).on('submit', '#allinwriter-form', function (e) {
        e.preventDefault();
        const data = {
            action: 'allinwriter_generate_article',
            security: allinwriter_vars.nonce,
            keyword: $('#allinwriter-keyword').val(),
            language: $('#allinwriter-language').val(),
            country: $('#allinwriter-country').val(),
            type: $('#allinwriter-type').val(),
            description: $('#allinwriter-description').val(),
            rewrite_text: $('#allinwriter-rewrite-text').val(),
            post_id: allinwriter_vars.allinwriter_post_id
        };

        let actionMethod = data["type"];

        if (allinWriterWPSocketConnections.size >= ALLINWRITER_MAX_CONNECTIONS) {
            toastr.warning('You cannot have more than 5 active actions at the same time.', 'Limit Reached', allinWriterWPWarningOptions);
            return;
        }

        let maxTimeToLoad = 56000;
        let durationText = "";

        if (actionMethod === "generateArticle") {
            maxAttempts = 20;
            maxTimePerAttempt = 7000;
            maxTimeToLoad = maxAttempts * maxTimePerAttempt;
            durationText = "Your article will be ready in 1-3 minutes.<br>Just a little longer! Your SEO magic is currently brewing in the AllinWriter pot.";
            createProgressBarPreloader(["Sending data to AllinWriter.com...", "Researching your keyword on the internet...", "Extracting data from the internet...", "Writing your Article...", "Optimizing your Article SEO...", "Complete!"], maxTimeToLoad, durationText);
        } else if (actionMethod === "generateArticlePRO") {
            maxAttempts = 20;
            maxTimePerAttempt = 30000;
            maxTimeToLoad = maxAttempts * maxTimePerAttempt;
            durationText = "Your PRO article will be ready in 5-8 minutes.<br>Your content is climbing the SEO ladder! Ready to reach the top in just a few moments.";
            createProgressBarPreloader(["Sending data to AllinWriter.com...", "Researching your keyword on the internet...", "Extracting data from the internet...", "Writing your Article...", "Optimizing your Article SEO...", "Complete!"], maxTimeToLoad, durationText);
        }

        $('#allinwriter-modal').fadeOut(function () {
            $(this).remove();
        });

        $.ajax({
            url: allinwriter_vars.ajax_url,
            type: 'POST',
            data: data,
            success: function (response) {
                if (response.success) {
                    pollJobStatus(response.data.job_id);
                } else {
                    toastr.error(response.data.message);
                    stopPreloader();
                }
            }
        });
    });

    function pollJobStatus(job_id) {
        let attempts = 0;
        const intervalId = setInterval(function () {
            if (attempts >= maxAttempts) {
                clearInterval(intervalId);
                return toastr.warning('The article generation process took too long.');
            }

            $.ajax({
                url: allinwriter_vars.ajax_url,
                type: 'POST',
                data: {
                    action: 'allinwriter_check_status',
                    security: allinwriter_vars.nonce,
                    job_id: job_id
                },
                success: function (response) {
                    if (response.success) {
                        clearInterval(intervalId);
                        var currentUrl = window.location.pathname;

                        if (currentUrl.includes('post-new.php')) {
                            var lastPostId = response.data.post_id;
                            var editPostUrl = allinwriter_vars.admin_url + 'post.php?post=' + lastPostId + '&action=edit';
                            window.location.href = editPostUrl;
                        } else {
                            window.location.reload();
                        }
                        stopPreloader();
                    }
                }
            });

            attempts++;
        }, maxTimePerAttempt);
    }
});