<?php
/**
 * SEO Articles by AllinWriter - AI SEO Tool.
 *
 * @package   WPSEOARTICLES
 * @copyright Copyright (C) 2022-2024, ALLINWRITER S.R.L. - office@allinwriter.com
 * @license   http://www.gnu.org/licenses/gpl-3.0.html GNU General Public License, version 3 or higher
 *
 * @wordpress-plugin
 * Plugin Name: SEO Articles by AllinWriter - AI SEO Tool
 * Version:     1.0
 * Plugin URI:  https://www.allinwriter.com/tools/seo-articles-writer
 * Description: Generating SEO articles with high scoring using an AI SEO tool enhances content ranking, aiming for top Google positions.
 * Author:      AllinWriter
 * Author URI:  https://allinwriter.com
 * Text Domain: seo-articles-by-allinwriter
 * License:     GPL v3
 * Requires at least: 6.5
 * Requires PHP: 7.2.5
 *
 * WC requires at least: 7.1
 * WC tested up to: 9.3
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

defined( 'ABSPATH' ) || exit;

if ( ! defined( 'SEO_BY_ALLINWRITER_FILE' ) ) {
	define( 'SEO_BY_ALLINWRITER_FILE', __FILE__ );
}

if ( ! defined( 'SEO_BY_ALLINWRITER_VERSION' ) ) {
	define( 'SEO_BY_ALLINWRITER_VERSION', '1.0' );
}

// Load the SEO Article by AllinWriter plugin.
require_once dirname( SEO_BY_ALLINWRITER_FILE ) . '/seo-aw-main.php';